public:

// Pre: El parámetro implicito es vacío, v = V. V no contiene elementos repetidos.
void cons_arbre_cerca(vector<T>& v) {
  sort(v.begin(), v.end());
  primer = i_cons_arbre_cerca(v, 0, v.size() - 1); 
}
// Post: El parámetro implícito contiene el árbol de búsqueda de V.



// Pre: El parámetro implícito es un árbol de búsqueda de un conjunto C
bool cerca(const T& x) const {
  return i_cerca(primer, x); 
}
// Post: El resultado indica si x pertenece a C.



private:


// Pre: 0 <= i, j < v.size()
static Node2* i_cons_arbre_cerca(const vector<T>& v, int i, int j) {
  if (i > j) return NULL;
  else {
     int k = (i+j)/2;
     Node2* n = new Node2;
     n->info = v[k];
     n->segE = i_cons_arbre_cerca(v, i, k-1);
     n->segD = i_cons_arbre_cerca(v, k+1, j);
     return n;
  }
}
// Post: El resultado apunta a una jerarquía de nodos que representa
// el árbol de búsqueda de v[i...j]. 

 

// Pre: m apunta a la raíz de una jerarquía de nodos que representa
// el árbol de búsqueda de un conjunto C.
static bool i_cerca(Node2* m, const T& x) {
  if (m == NULL) return false;
  else if (m->info == x) return true;
  else if (m->info > x) return i_cerca(m->segE, x); 
  else return i_cerca(m->segD, x);
}
// Post: El resultado indica si x pertenece a C.
