public:

bool buscaN(const T &x) const {
/* Pre: El tipo T tiene definida la operación de comparación de igualdad. */ 
/* Post: El resultado indica si el p.i. contiene un nodo cuyo valor es igual a x. */
  return busca_aux(primer,x) != nullptr ;
}


private:

static Node* busca_aux (Node* n, const T &x) {
/* Pre: El tipo T tiene definida la operación de comparación de igualdad. 
n apunta al primer nodo de una jerarquía de nodos. */ 
/* Post: Si la jerarquía de nodos a la que apunta n contiene algún nodo cuyo 
valor es igual a x, el resultado apunta al primero de dichos nodos en preorden; 
en otro caso, el resultado apunta a nullptr. */
  if (n == nullptr) return nullptr;
  else if (n->info == x) return n; 
  else {
    int ari = (n->seg).size();
    for (int i = 0; i < ari; ++i) {
      Node* r = busca_aux(n->seg[i], x); 
      if (r != nullptr) return r; 
    }
    return nullptr;
  }
}


